/*********************************************************************
 *  Cg[T hCo֐
 *  CQ-7144B pCJ HEW V4.05.01.001
 ********************************************************************/

#include "iodefine.h"
#include "driver.h"
#include <machine.h>	// for set_imask()

/*********************************************************************
 * CPU , Memory
 ********************************************************************/
void cpu_init(void)
{
	/* O SRAM ~ */
	PFC.PACRL1.BIT.PA11MD = 0;
	PFC.PAIORL.BIT.B11 = 1;
	PA.DR.BIT.B11 = 1;	/* nCS1=High */
}

/*********************************************************************
 * PWM(MTU)
 ********************************************************************/
#define PWM_PERIOD_COUNT		6000	/* NbN 6000KHz Ȃ̂Ŏ 1kHz */
#define PWM_INITIAL_DUTY_COUNT	PWM_PERIOD_COUNT / 5	/* 20 */

#define PWM_STATUS_ENABLE	1
#define PWM_STATUS_DISABLE	0

void pwm_init(void)
{
	/* MTUݒ */
	MST.CR2.BIT._MTU  = 0;	/* W[X^oC̉ */
	MTU.TSTR.BYTE     = 0;	/* JE^̒~ */

	/* TIOC4A,B̂߂̐ݒ */
	MTU3.TCR.BIT.TPSC = 1;	/* NbN̕ݒ */
	MTU3.TCR.BIT.CCLR = 1;	/* TGRÃRyA}b`TCNT̃NA */
	MTU3.TGRA = PWM_PERIOD_COUNT;	/* Zbg */
	MTU4.TGRA = PWM_INITIAL_DUTY_COUNT;	/* f[eB[Zbg */
	MTU4.TGRB = PWM_INITIAL_DUTY_COUNT;	/* f[eB[Zbg */
	MTU.TOCR.BIT.PSYE = 1;	/* PWMo͋ */
	MTU.TOCR.BIT.OLSN = 1;	/* PWMf[eBɈvLowx */
	MTU3.TMDR.BIT.MD = 8;	/* ZbgPWM[hɐݒ */

	/* JE^Zbg */
	MTU3.TCNT = 0;
	MTU4.TCNT = 0;

	/* sݒ */
	PFC.PECRL1.BIT.PE12MD	= 1;	// PE12  TIOC4Ao ɐݒ
	PFC.PEIORL.BIT.B12		= 1;	// o͐ݒ
	PFC.PECRL1.BIT.PE13MD	= 1;	// PE13  TIOC4Bo ɐݒ
	PFC.PEIORL.BIT.B13		= 1;	// o͐ݒ

	/*
	 * PWM ͂ꂼ Qӏo͂̂ŁCo͂Ȃs
	 * ͂ɐݒ肵ĂDiPWMM̏Փ˂邽߁j
	 */
	PFC.PECRL1.BIT.PE9MD	= 0;	// PE9 I/O ɐݒ
	PFC.PEIORL.BIT.B9		= 0;	// ͐ݒ
	PFC.PECRL1.BIT.PE15MD	= 0;	// PE15 I/O ɐݒ
	PFC.PEIORL.BIT.B15		= 0;	// ͐ݒ
	PFC.PACRL2.BIT.PA5MD	= 0;	// PA5  I/O ɐݒ
	PFC.PAIORL.BIT.B5		= 0;	// ͐ݒ
	PFC.PACRL2.BIT.PA2MD	= 0;	// PA2  I/O ɐݒ
	PFC.PAIORL.BIT.B2		= 0;	// ͐ݒ
}

void pwm_start(int arg_no)
{
	switch(arg_no){
	case 1:
		MTU.TSTR.BIT.CST3 = 0;	// JEgXgbv
		MTU3.TCNT = 0;
		MTU4.TCNT = 0;
		MTU.TOER.BIT.OE4A = 1;	/* TIOC4A[qMTUo͋ */
		MTU.TSTR.BIT.CST3 = 1;	// JEgX^[g
		break;
	case 2:
		MTU.TSTR.BIT.CST3 = 0;	// JEgXgbv
		MTU3.TCNT = 0;
		MTU4.TCNT = 0;
		MTU.TOER.BIT.OE4B = 1;	/* TIOC4B[qMTUo͋ */
		MTU.TSTR.BIT.CST3 = 1;	// JEgX^[g
		break;
	case 3:
		/*  */
		break;
	default:
		break;
	}
}

void pwm_stop(int arg_no)
{
	switch(arg_no){
	case 1:
		MTU.TSTR.BIT.CST3 = 0;	// JEgXgbv
		MTU3.TCNT = 0;
		MTU4.TCNT = 0;
		MTU.TOER.BIT.OE4A = 0;	/* TIOC4A[qMTUo͋֎~ */
		MTU.TSTR.BIT.CST3 = 1;	// JEgX^[g
		break;
	case 2:
		MTU.TSTR.BIT.CST3 = 0;	// JEgXgbv
		MTU3.TCNT = 0;
		MTU4.TCNT = 0;
		MTU.TOER.BIT.OE4B = 0;	/* TIOC4B[qMTUo͋֎~ */
		MTU.TSTR.BIT.CST3 = 1;	// JEgX^[g
		break;
	case 3:
		/*  */
		break;
	default:
		break;
	}
}

/*
 * 0%, 100% ͈Ӑ}g`ɂȂȂ̂ŔĂ
 *
 * SH7144ł́CEgK}b`̋ʂ}b`ŏo̓gOƂȂD
 * ܂CgKWX^̃obt@@\݂ȂDQ̂Ƃ
 * PWMo͒ɃgKݒ肷ƁC^C~OɂĂ͐ݒ肵f[eB䂪
 * ȂȂ(20%  80%, 40%  60% ȂǂƂȂ)D
 * ̂߁Cf[eBύXɂ͈UPWMo͂~
 */
#define DUTY_MIN	1
#define DUTY_MAX	99
void pwm1_set_ratio(int arg_percent)
{
	if(arg_percent < DUTY_MIN){
		arg_percent = DUTY_MIN;
	}
	if(arg_percent > DUTY_MAX){
		arg_percent = DUTY_MAX;
	}

	MTU.TSTR.BIT.CST3 = 0;	// JEgXgbv
	MTU3.TCNT = 0;
	MTU4.TCNT = 0;
	MTU4.TGRA = (PWM_PERIOD_COUNT / 100) * arg_percent;
	MTU.TSTR.BIT.CST3 = 1;	// JEgX^[g
}

void pwm2_set_ratio(int arg_percent)
{
	if(arg_percent < DUTY_MIN){
		arg_percent = DUTY_MIN;
	}
	if(arg_percent > DUTY_MAX){
		arg_percent = DUTY_MAX;
	}

	MTU.TSTR.BIT.CST3 = 0;	// JEgXgbv
	MTU3.TCNT = 0;
	MTU4.TCNT = 0;
	MTU4.TGRB = (PWM_PERIOD_COUNT / 100) * arg_percent;
	MTU.TSTR.BIT.CST3 = 1;	// JEgX^[g
}

void pwm3_set_ratio(int arg_percent)
{
/*  */
}

/******************************************************************************
 * PIN Control(I/O Port)
 * H} Pn M͑SẴO[vɑ
 *****************************************************************************/
void pin_init(void)
{
	/* P20~23 Ms */
	PFC.PDCRL2.BIT.PD8MD = 0;
	PFC.PDCRL2.BIT.PD9MD = 0;
	PFC.PDCRL2.BIT.PD10MD = 0;
	PFC.PDCRL2.BIT.PD11MD = 0;
	PFC.PDIORL.BIT.B8 = 1;
	PFC.PDIORL.BIT.B9 = 1;
	PFC.PDIORL.BIT.B10 = 1;
	PFC.PDIORL.BIT.B11 = 1;
	PD.DR.BIT.B9 = 0;
	PD.DR.BIT.B8 = 0;
	PD.DR.BIT.B10 = 0;
	PD.DR.BIT.B11 = 0;

	/* P30~35 Ms */
	PFC.PDCRL1.BIT.PD0MD	= 0;
	PFC.PDCRL1.BIT.PD1MD	= 0;
	PFC.PDCRL1.BIT.PD2MD	= 0;
	PFC.PDCRL1.BIT.PD3MD	= 0;
	PFC.PDCRL1.BIT.PD4MD	= 0;
	PFC.PDCRL1.BIT.PD5MD	= 0;
	PFC.PDIORL.BIT.B0	= 1;
	PFC.PDIORL.BIT.B1	= 1;
	PFC.PDIORL.BIT.B2	= 1;
	PFC.PDIORL.BIT.B3	= 1;
	PFC.PDIORL.BIT.B4	= 1;
	PFC.PDIORL.BIT.B5	= 1;
	PD.DR.BIT.B0 = 0;
	PD.DR.BIT.B1 = 0;
	PD.DR.BIT.B2 = 0;
	PD.DR.BIT.B3 = 0;
	PD.DR.BIT.B4 = 0;
	PD.DR.BIT.B5 = 0;
}

void p20_set(int arg_status)
{
	PD.DR.BIT.B8 = arg_status;
}

void p21_set(int arg_status)
{
	PD.DR.BIT.B9 = arg_status;
}

void p22_set(int arg_status)
{
	PD.DR.BIT.B10 = arg_status;
}

void p23_set(int arg_status)
{
	PD.DR.BIT.B11 = arg_status;
}

void p30_set(int arg_status)
{
	PD.DR.BIT.B0 = arg_status;
}

void p31_set(int arg_status)
{
	PD.DR.BIT.B1 = arg_status;
}

void p32_set(int arg_status)
{
	PD.DR.BIT.B2 = arg_status;
}

void p33_set(int arg_status)
{
	PD.DR.BIT.B3 = arg_status;
}

void p34_set(int arg_status)
{
	PD.DR.BIT.B4 = arg_status;
}

void p35_set(int arg_status)
{
	PD.DR.BIT.B5 = arg_status;
}

/******************************************************************************
 * Analog Digital Converter
 *****************************************************************************/
#define AD_VALUE_MAX	0x03FF

void ad_init(void)
{
	/* W[X^oC̉ */
	MST.CR2.BIT._AD0 = 0;
	MST.CR2.BIT._AD1 = 0;

	/* AD0̐ݒ */
	AD0.ADCR.BIT.ADST = 0;	// A/Dϊ~
	AD0.ADCR.BIT.TRGE = 0;	// gK[ɂJn𖳌
	AD0.ADCR.BIT.ADCS = 1;	// A/D PTCNXL
	AD0.ADCR.BIT.CKS  = 3;	// ϊԂő P/4 ɐݒ

	AD0.ADCSR.BIT.ADM  = 0;	// 샂[hVO[hɐݒ
	AD0.ADCSR.BIT.ADIE = 0;	// 荞݂֎~

	/* AD1̐ݒ */
	AD1.ADCR.BIT.ADST = 0;	// A/Dϊ~
	AD1.ADCR.BIT.TRGE = 0;	// gK[ɂJn𖳌
	AD1.ADCR.BIT.ADCS = 1;	// A/D PTCNXL
	AD1.ADCR.BIT.CKS  = 3;	// ϊԂő P/4 ɐݒ

	AD1.ADCSR.BIT.ADM  = 0;	// 샂[hVO[hɐݒ
	AD1.ADCSR.BIT.ADIE = 0;	// 荞݂֎~
}

int ad00_get(void)
{
	int ad_result;
	int timeout;

	AD0.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD0.ADCSR.BIT.CH = 0;	// `l AN0 I
	AD0.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD0.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD0.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD0.ADDR0.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;
}

int ad01_get(void)
{
	int ad_result;
	int timeout;

	AD0.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD0.ADCSR.BIT.CH = 1;	// `l AN1 I
	AD0.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD0.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD0.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD0.ADDR1.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;
}

int ad02_get(void)
{
	int ad_result;
	int timeout;

	AD0.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD0.ADCSR.BIT.CH = 2;	// `l AN2 I
	AD0.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD0.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD0.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD0.ADDR2.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;
}

int ad03_get(void)
{
	int ad_result;
	int timeout;

	AD0.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD0.ADCSR.BIT.CH = 3;	// `l AN3 I
	AD0.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD0.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD0.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD0.ADDR3.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;
}

int ad04_get(void)
{
	int ad_result;
	int timeout;

	AD1.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD1.ADCSR.BIT.CH = 0;	// `l AN4 I
	AD1.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD1.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD1.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD1.ADDR4.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;
}

int ad05_get(void)
{
	int ad_result;
	int timeout;

	AD1.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD1.ADCSR.BIT.CH = 1;	// `l AN5 I
	AD1.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD1.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD1.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD1.ADDR5.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;
}

int ad06_get(void)
{
	int ad_result;
	int timeout;

	AD1.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD1.ADCSR.BIT.CH = 2;	// `l AN6 I
	AD1.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD1.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD1.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD1.ADDR6.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;

}

int ad07_get(void)
{
	int ad_result;
	int timeout;

	AD1.ADCR.BIT.ADST = 0;	// Ô A/Dϊ~
	AD1.ADCSR.BIT.CH = 3;	// `l AN7 I
	AD1.ADCR.BIT.ADST = 1;	// A/Dϊ Jn
	timeout = 1000;
	while(AD1.ADCSR.BIT.ADF==0 && timeout > 0){	// ϊtOZbg܂ő҂
		timeout--;
	}
	if(timeout > 0){	// ^CAEgĂȂΕϊlԂ
		AD1.ADCSR.BIT.ADF = 0;	// tONA
		ad_result = (AD1.ADDR7.WORD >> 6) & 0x000003FF;	// ϊl͏ 10 rbg
	}else{
		ad_result = 0;	// ϊ^CAEgȂ 0 Ƃ
	}
	ad_result = (ad_result * 100) / AD_VALUE_MAX;
	return ad_result;
}

/******************************************************************************
 * Timer
 *****************************************************************************/
void timer_init(void)
{
	/* RyA}b`^C}W[X^oC */
	MST.CR2.BIT._CMT = 0;
	
	/* RyA}b`^C}Rg[WX^ݒ */
	CMT0.CMCSR.BIT.CKS = 0;		// NbNI = P/8

	/* RyA}b`^C}RX^gWX^ݒ */
	CMT0.CMCOR = 3000;			// JE^ 3000 ŃRyA}b` <=> 1msec^C}

	CMT0.CMCNT = 0;	// JE^Zbg
}

void timer_start(void)
{
	/* RyA}b`^C}X^[gWX^ݒ */
	CMT.CMSTR.BIT.STR0 = 1;		// ^C}JEgX^[g
}

void timer_stop(void)
{
	/* RyA}b`^C}X^[gWX^ݒ */
	CMT.CMSTR.BIT.STR0 = 0;		// ^C}JEgXgbv
	CMT0.CMCNT = 0;	// JE^Zbg
}

int timer_check_match(void)
{
	int is_match;
	
	if(CMT0.CMCSR.BIT.CMF == 1){	// RyA}b`tO`FbN
		CMT0.CMCSR.BIT.CMF = 0;		// RyA}b`tONA
		is_match = TIMER_CHECK_MATCH_TRUE;
	}else{
		is_match = TIMER_CHECK_MATCH_FALSE;
	}
	
	return is_match;
}
