/********************************************************************
 *  Cg[T Cu֐ Rev 2.0
 ********************************************************************/

#include "driver.h"
#include "ltr_lib.h"
#include "ltr_lib_config.h"

/********************************************************************
 *  
 ********************************************************************/
void init(void)
{
    cpu_init();
    pin_init();
    pwm_init();
    ad_init();
    timer_init();

	pwm_start(RIGHT_MTR_PWM_NO);
	pwm_start(LEFT_MTR_PWM_NO);
}

/********************************************************************
 *  ėp
 ********************************************************************/
void wait(int arg_time)
{
    int wait_time;
		wait_time = arg_time * WAIT_BASE_TIME;

    if (wait_time < 0) {
        wait_time = 1;
    }

    timer_start();
    while (wait_time > 0) {
    while (timer_check_match() == TIMER_CHECK_MATCH_FALSE){;}
        wait_time--;
    }
    timer_stop();
}

/********************************************************************
 *  [^[
 ********************************************************************/
#define MTR_NONE    0
#define MTR_BACK    1
#define MTR_FORWARD 2
#define MTR_STOP    3
static void MTR1_direction_set(int arg_parameter);
static void MTR2_direction_set(int arg_parameter);
static void MTR3_direction_set(int arg_parameter);

static void MTR1_direction_set(int arg_parameter)
{
	switch(arg_parameter){
	case MTR_NONE:
		p30_set(PIN_LOW);
		p31_set(PIN_LOW);
		break;
	case MTR_BACK:
		p30_set(PIN_HIGH);
		p31_set(PIN_LOW);
		break;
	case MTR_FORWARD:
		p30_set(PIN_LOW);
		p31_set(PIN_HIGH);
		break;
	case MTR_STOP:
		p30_set(PIN_HIGH);
		p31_set(PIN_HIGH);
		break;
	default:
		break;
	}
}

static void MTR2_direction_set(int arg_parameter)
{
	switch(arg_parameter){
	case MTR_NONE:
		p32_set(PIN_LOW);
		p33_set(PIN_LOW);
		break;
	case MTR_BACK:
		p32_set(PIN_HIGH);
		p33_set(PIN_LOW);
		break;
	case MTR_FORWARD:
		p32_set(PIN_LOW);
		p33_set(PIN_HIGH);
		break;
	case MTR_STOP:
		p32_set(PIN_HIGH);
		p33_set(PIN_HIGH);
		break;
	default:
		break;
	}
}

static void MTR3_direction_set(int arg_parameter)
{
	switch(arg_parameter){
	case MTR_NONE:
		p34_set(PIN_LOW);
		p35_set(PIN_LOW);
		break;
	case MTR_BACK:
		p34_set(PIN_HIGH);
		p35_set(PIN_LOW);
		break;
	case MTR_FORWARD:
		p34_set(PIN_LOW);
		p35_set(PIN_HIGH);
		break;
	case MTR_STOP:
		p34_set(PIN_HIGH);
		p35_set(PIN_HIGH);
		break;
	default:
		break;
	}
}

void forward(void)
{
	/* Eԗ֐] */
#if RIGHT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_FORWARD);
#elif RIGHT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_FORWARD);
#elif RIGHT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_FORWARD);
#endif

	/* ԗ֐] */
#if LEFT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_FORWARD);
#elif LEFT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_FORWARD);
#elif LEFT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_FORWARD);
#endif
}

void back(void)
{
	/* Eԗ֋t] */
#if RIGHT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_BACK);
#elif RIGHT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_BACK);
#elif RIGHT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_BACK);
#endif

	/* ԗ֋t] */
#if LEFT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_BACK);
#elif LEFT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_BACK);
#elif LEFT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_BACK);
#endif
}

void right(void)
{
	/* Eԗ֋t] */
#if RIGHT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_BACK);
#elif RIGHT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_BACK);
#elif RIGHT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_BACK);
#endif

	/* ԗ֐] */
#if LEFT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_FORWARD);
#elif LEFT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_FORWARD);
#elif LEFT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_FORWARD);
#endif
}

void left(void)
{
	/* Eԗ֐] */
#if RIGHT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_FORWARD);
#elif RIGHT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_FORWARD);
#elif RIGHT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_FORWARD);
#endif

	/* ԗ֋t] */
#if LEFT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_BACK);
#elif LEFT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_BACK);
#elif LEFT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_BACK);
#endif
}

void stop(void)
{
	/* Eԗ֐] */
#if RIGHT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_STOP);
#elif RIGHT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_STOP);
#elif RIGHT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_STOP);
#endif

	/* ԗ֋t] */
#if LEFT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_STOP);
#elif LEFT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_STOP);
#elif LEFT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_STOP);
#endif
}

void halt(void)
{
	/* Eԗ֐] */
#if RIGHT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_NONE);
#elif RIGHT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_NONE);
#elif RIGHT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_NONE);
#endif

	/* ԗ֋t] */
#if LEFT_MTR_CONNECT == 1
    MTR1_direction_set(MTR_NONE);
#elif LEFT_MTR_CONNECT == 2
    MTR2_direction_set(MTR_NONE);
#elif LEFT_MTR_CONNECT == 3
    MTR3_direction_set(MTR_NONE);
#endif
}

void speed_right(int arg_percentage)
{
    if (arg_percentage < 0) {
        arg_percentage = 0;
    } else if (arg_percentage > 100) {
        arg_percentage = 100;
    }
#if RIGHT_MTR_CONNECT == 1
    pwm1_set_ratio(arg_percentage);
#elif RIGHT_MTR_CONNECT == 2
    pwm2_set_ratio(arg_percentage);
#elif RIGHT_MTR_CONNECT == 3
    pwm3_set_ratio(arg_percentage);
#endif
}

void speed_left(int arg_percentage)
{
    if (arg_percentage < 0) {
        arg_percentage = 0;
    } else if (arg_percentage > 100) {
        arg_percentage = 100;
    }
#if LEFT_MTR_CONNECT == 1
    pwm1_set_ratio(arg_percentage);
#elif LEFT_MTR_CONNECT == 2
    pwm2_set_ratio(arg_percentage);
#elif LEFT_MTR_CONNECT == 3
    pwm3_set_ratio(arg_percentage);
#endif
}

/********************************************************************
 *  A/DRo[^
 ********************************************************************/
int adin(int arg_channel)
{
    int ret_value;

    /* Ώۃ`l̃AiOl擾 */
    switch (arg_channel) {
    case 0:
        ret_value = ad00_get();
        break;
    case 1:
        ret_value = ad01_get();
        break;
    case 2:
        ret_value = ad02_get();
        break;
    case 3:
        ret_value = ad03_get();
        break;
    case 4:
        ret_value = ad04_get();
        break;
    case 5:
        ret_value = ad05_get();
        break;
    case 6:
        ret_value = ad06_get();
        break;
    case 7:
        ret_value = ad07_get();
        break;
    default:
        ret_value = 0;  /* sȃ`l̏ꍇ */
        break;
    }

    return ret_value;
}

/********************************************************************
 *  LED
 ********************************************************************/
void led_on(int arg_no)
{
    switch (arg_no) {
    case LED1:
        p20_set(PIN_HIGH);
        break;
    case LED2:
        p21_set(PIN_HIGH);
        break;
    case LED3:
        p22_set(PIN_HIGH);
        break;
    case LED4:
        p23_set(PIN_HIGH);
        break;
    default:
        /* Ȃ */
        break;
    }
}

void led_off(int arg_no)
{
    switch (arg_no) {
    case LED1:
        p20_set(PIN_LOW);
        break;
    case LED2:
        p21_set(PIN_LOW);
        break;
    case LED3:
        p22_set(PIN_LOW);
        break;
    case LED4:
        p23_set(PIN_LOW);
        break;
    default:
        /* Ȃ */
        break;
    }
}
